
// TestRTFSetRedrawDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestRTFSetRedraw.h"
#include "TestRTFSetRedrawDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestRTFSetRedrawDlg dialog




CTestRTFSetRedrawDlg::CTestRTFSetRedrawDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestRTFSetRedrawDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestRTFSetRedrawDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ED_RTF, m_wndEdRTF);
	DDX_Control(pDX, IDC_BT_SHOW, m_wndBtnShow);
}

BEGIN_MESSAGE_MAP(CTestRTFSetRedrawDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BT_DOIT, &CTestRTFSetRedrawDlg::OnBnClickedBtDoit)
	ON_BN_CLICKED(IDC_BT_SHOW, &CTestRTFSetRedrawDlg::OnBnClickedBtShow)
END_MESSAGE_MAP()


// CTestRTFSetRedrawDlg message handlers

BOOL CTestRTFSetRedrawDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// set initial state
	m_wndBtnShow.SetCheck((GetStyle() & WS_VISIBLE)!=0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestRTFSetRedrawDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestRTFSetRedrawDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestRTFSetRedrawDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestRTFSetRedrawDlg::OnBnClickedBtDoit()
{
	bool bWasVisible = (m_wndEdRTF.GetStyle() & WS_VISIBLE)!=0;
	m_wndEdRTF.SetRedraw(FALSE);
	m_wndEdRTF.SetWindowText(_T("Line 1\r\nLine 2\r\nLine 3\r\nLine 4"));
	m_wndEdRTF.SetSel(0,0);
	m_wndEdRTF.SetRedraw(TRUE);
	m_wndEdRTF.Invalidate();
	bool bIsVisible = (m_wndEdRTF.GetStyle() & WS_VISIBLE)!=0;

	// Check if the visible state changed
	if (bIsVisible!=bWasVisible)
		AfxMessageBox(_T("The visible state of the RTF control changed!"));
}

void CTestRTFSetRedrawDlg::OnBnClickedBtShow()
{
	bool bShow = m_wndBtnShow.GetCheck()!=0;
	m_wndEdRTF.ShowWindow(bShow ? SW_SHOW : SW_HIDE);
}
